﻿using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RealName
{
    public partial class FormMain : Form
    {
        public FormMain()
        {
            InitializeComponent();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            //获取鉴权Token
            //token有效时长为120分钟。如果有多台机器建议使用分布式存储，新旧token会共存5分钟。请把token做全局唯一
            //发送Http GET请求
            string apiUrl = Config.APIConfig.access_token + "?appId=" + Config.Config.AppId + "&secret=" + Config.Config.App_Secret + "&grantType=client_credentials";
            textBox1.Text = apiUrl;
            String token = Core.GetToken.token(apiUrl);
            if (!string.IsNullOrEmpty(token))
            {
                textBox2.Text = token;
            }
            else
            {
                textBox2.Text = "token获取失败";
            }
        }
        private void button1_Click_1(object sender, EventArgs e)
        {

            //信息比对

            //弹出输入框，让用户填写姓名和身份证

            Individual individual = new Individual();
            if (individual.ShowDialog() == DialogResult.OK)
            {
                String name = individual.TextBoxValue;
                String idNo = individual.TextBoxValue2;
                individual.Close();

                //获取token
                //token有效时长为120分钟。如果有多台机器建议使用分布式存储，新旧token会共存5分钟。请把token做全局唯一
                string apiUrl = Config.APIConfig.access_token + "?appId=" + Config.Config.AppId + "&secret=" + Config.Config.App_Secret + "&grantType=client_credentials";

                String token = Core.GetToken.token(apiUrl);
                if (!string.IsNullOrEmpty(token))
                {
                    //拼接创建个人账户JSON字符串，当作请求body体
                    JObject dataJson = new JObject();
                    dataJson.Add("name", name);
                    dataJson.Add("idNo", idNo);
                    textBox1.Text = dataJson.ToString();

                    // 获取API调用地址
                    string apiUrlgetAccont = Config.APIConfig.get_individualBase;
                    // 构建请求头
                    Dictionary<string, string> headers = Http.SendHttp.buildHeaders(Config.Config.AppId, token);
                    // HTTP请求内容类型
                    string contentType = "application/json";
                    string result = Http.SendHttp.Post(apiUrlgetAccont, headers, dataJson.ToString(), contentType);
                    textBox2.Text = result;
                }
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            //驾驶证OCR

            //token有效时长为120分钟。如果有多台机器建议使用分布式存储，新旧token会共存5分钟。请把token做全局唯一
            string apiUrl = Config.APIConfig.access_token + "?appId=" + Config.Config.AppId + "&secret=" + Config.Config.App_Secret + "&grantType=client_credentials";
            String token = Core.GetToken.token(apiUrl);

            //选择驾驶证
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Multiselect = false;//该值确定是否可以选择多个文件
            dialog.Title = "请选择文件夹";
            dialog.Filter = "图像文件(*.jpg;*.png)|*.jpg;*.png";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                //选择的文件路径

                string file = dialog.FileName;
                //把图片转成Base64
                String data = Core.GetFileInfo.ImageToBase64(file);

                if (!string.IsNullOrEmpty(token))
                {
                    //拼接创建个人账户JSON字符串，当作请求body体
                    JObject dataJson = new JObject();
                    dataJson.Add("image", data);

                    // 获取API调用地址
                    string apiUrlgetAccont = Config.APIConfig.ocr_drivinglicence;
                    // 构建请求头
                    Dictionary<string, string> headers = Http.SendHttp.buildHeaders(Config.Config.AppId, token);
                    // HTTP请求内容类型
                    string contentType = "application/json";
                    string result = Http.SendHttp.Post(apiUrlgetAccont, headers, dataJson.ToString(), contentType);
                    textBox2.Text = result;
                    //textBox1.Text = dataJson.ToString();
                    textBox1.Text = "请求参数暂不输出！！！";
                }

            }

        }

        private void button3_Click(object sender, EventArgs e)
        {
            //创建个人账户
            //弹出输入框，让用户填写姓名和身份证，手机和邮箱

            Account account = new Account();
            if (account.ShowDialog() == DialogResult.OK)
            {
                String name = account.TextBoxValue;
                String idNumber = account.TextBoxValue2;
                String mobile = account.TextBoxValue3;
                String email = account.TextBoxValue4;
                account.Close();

                //获取token
                //token有效时长为120分钟。如果有多台机器建议使用分布式存储，新旧token会共存5分钟。请把token做全局唯一
                string apiUrl = Config.APIConfig.access_token + "?appId=" + Config.Config.AppId + "&secret=" + Config.Config.App_Secret + "&grantType=client_credentials";

                String token = Core.GetToken.token(apiUrl);
                if (!string.IsNullOrEmpty(token))
                {
                    //拼接创建个人账户JSON字符串，当作请求body体
                    JObject dataJson = new JObject();
                    dataJson.Add("thirdPartyUserId", DateTime.Now.ToFileTimeUtc().ToString());
                    dataJson.Add("name", name);
                    dataJson.Add("idType", Config.ParameterConfig.idType);
                    dataJson.Add("idNumber", idNumber);
                    dataJson.Add("mobile", mobile);
                    dataJson.Add("email", email);
                    textBox1.Text = dataJson.ToString();

                    // 获取API调用地址
                    string apiUrlgetAccont = Config.APIConfig.get_account;
                    // 构建请求头
                    Dictionary<string, string> headers = Http.SendHttp.buildHeaders(Config.Config.AppId, token);
                    // HTTP请求内容类型
                    string contentType = "application/json";
                    string result = Http.SendHttp.Post(apiUrlgetAccont, headers, dataJson.ToString(), contentType);
                    textBox2.Text = result;
                }
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //个人网页版实名接口
            //获取token
            //token有效时长为120分钟。如果有多台机器建议使用分布式存储，新旧token会共存5分钟。请把token做全局唯一
            string apiUrl = Config.APIConfig.access_token + "?appId=" + Config.Config.AppId + "&secret=" + Config.Config.App_Secret + "&grantType=client_credentials";

            String token = Core.GetToken.token(apiUrl);
            if (!string.IsNullOrEmpty(token))
            {
                //拼接创建个人账户JSON字符串，当作请求body体
                JObject dataJson = new JObject();
                dataJson.Add("repeatIdentity", Config.ParameterConfig.repeatIdentity);

                JObject contextInfo = new JObject();
                contextInfo.Add("notifyUrl", Config.ParameterConfig.notifyUrl);
                contextInfo.Add("origin", Config.ParameterConfig.origin);
                contextInfo.Add("redirectUrl", Config.ParameterConfig.redirectUrl);
                contextInfo.Add("showResultPage", Config.ParameterConfig.showResultPage);
                contextInfo.Add("contextInfo", contextInfo);

                JObject indivInfo = new JObject();
                indivInfo.Add("certNo", Config.ParameterConfig.certNo);
                indivInfo.Add("name", Config.ParameterConfig.name);
                dataJson.Add("indivInfo", indivInfo);

                textBox1.Text = dataJson.ToString();

                // 获取API调用地址
                string apiUrlgetAccont = Config.APIConfig.get_indivIdentityUrl(Config.ParameterConfig.accountId);
                // 构建请求头
                Dictionary<string, string> headers = Http.SendHttp.buildHeaders(Config.Config.AppId, token);
                // HTTP请求内容类型
                string contentType = "application/json";
                string result = Http.SendHttp.Post(apiUrlgetAccont, headers, dataJson.ToString(), contentType);
                textBox2.Text = result;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //查询认证信息
            //获取token
            //token有效时长为120分钟。如果有多台机器建议使用分布式存储，新旧token会共存5分钟。请把token做全局唯一
            string apiUrl = Config.APIConfig.access_token + "?appId=" + Config.Config.AppId + "&secret=" + Config.Config.App_Secret + "&grantType=client_credentials";

            String token = Core.GetToken.token(apiUrl);
            if (!string.IsNullOrEmpty(token))
            {
                // 获取API调用地址
                string apiUrlgetAccont = Config.APIConfig.get_detail(Config.ParameterConfig.flowId);
                textBox1.Text = apiUrlgetAccont;
                // 构建请求头
                Dictionary<string, string> headers = Http.SendHttp.buildHeaders(Config.Config.AppId, token);
                // HTTP请求内容类型
                string contentType = "application/json";
                string result = Http.SendHttp.Get(apiUrlgetAccont, headers, contentType);
                textBox2.Text = result;

            }
        }
    }
}
    
